<?php

namespace Teknisa\ACL\Repositories;

use Teknisa\ACL\Util\InstanceProvider;
use Teknisa\ACL\Repositories\BaseCrud;

class AclParamgeral extends BaseCrud {

    protected $table = 'OPERADOR';

    public function __construct()
    {
        parent::__construct($this->table);
    }

    public function getNrorg() {
        return InstanceProvider::getEnvironment()->getCurrentOrganizationId();
    }
    
    public function findAclParamgeral($organizationId)
    {
        $query = <<<SQL
            SELECT IDGERACDOPERADOR FROM PARAMGERAL 
             WHERE NRORG = $organizationId
            
SQL;

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query)[0];
    }
    
    
    public function GetHighiestCdoperador()
    {
        $nrorg = $this->getNrorg();
        $query = "SELECT MAX(CDOPERADOR) AS CDOPERADOR
              FROM OPERADOR 
             WHERE LTRIM(CDOPERADOR,'0123456789') IS NULL AND NRORG = " . $nrorg;

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query)[0];
    }
    
    
    public function saveAclParamgeral($idgeraoper, $organizationId)
    {
        $query = "
            UPDATE PARAMGERAL 
               SET IDGERACDOPERADOR = :IDGERACDOPERADOR
             WHERE NRORG = :NRORG";
             
        $params = array (
            "NRORG"         => $organizationId,
            "IDGERACDOPERADOR"         => $idgeraoper
        );
        
        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
    
    
    public function updateNewCodeValue($newCode, $organizationId)
    {
        $query = "
            UPDATE NOVOCODIGO 
               SET NRSEQUENCIAL = :NRSEQUENCIAL
             WHERE CDCONTADOR = :CDCONTADOR
             AND NRORG = :NRORG";
             
        $params = array (
            "CDCONTADOR"         => 'OPERADOR'.$organizationId,
            "NRSEQUENCIAL"         => $newCode,
            "NRORG"                 => $this->getNrorg(),
        );
        
        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
    
}